#include "hmg.ch"

*------------------------------------------*
* (c) Mustafa Lpez  mustalopez@gmail.com
*------------------------------------------*

  REQUEST DBFCDX , DBFFPT , DBFDBT ,SDDODBC, SQLMIX
  RDDSETDEFAULT( "DBFCDX" , "SQLMIX" )

*------------------------------------------------------------*
Function mPrinting() 
*------------------------------------------------------------* 

    DEFINE WINDOW Form_2s           ;
       AT 0,0                       ;
       WIDTH 300 HEIGHT 210         ; 
       MODAL NOSIZE NOCAPTION  
     
       ON KEY ESCAPE ACTION Form_2s.Release 
       ON KEY ALT+F4 ACTION NIL                                              
      
*------------------------------------------------------------*
  
    BoxShadow( 007, 006, 294, 205 ,"00sx" ,"00sz", 137,115,183 )  

        Form_2s.Label_00sx.Enabled := .F.
        Form_2s.Label_00sz.Enabled := .F.

*------------------------------------------------------------*

     DEFINE FRAME frame_02
         ROW 021  
         COL 090
         WIDTH  120  
         HEIGHT 098
         FONTNAME "Arial"
         FONTSIZE 9
         FONTBOLD .T.
         FONTITALIC .T.
         FONTUNDERLINE .F.
         FONTSTRIKEOUT .F.
         CAPTION "Printer"
         BACKCOLOR { 137,115,183 }  
         FONTCOLOR Nil
         OPAQUE .T.  
     END FRAME 

     DEFINE LABEL  Label_Print 
        ROW    038  
        COL    111  
        WIDTH  090
        HEIGHT 020
        VALUE "Printer List"
        FONTNAME "Arial"
        FONTSIZE 12
        TOOLTIP "Printer List"
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR { 137,115,183 }  
        FONTCOLOR NIL
    END LABEL

    DEFINE RADIOGROUP RadioGroup_Print
        ROW    060    
        COL    111 
        WIDTH  080
        HEIGHT 050
        OPTIONS {'Printer','File Pdf'}      
        VALUE 1
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP ""
        ONCHANGE nil    
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        TRANSPARENT .F.
        SPACING 25
        BACKCOLOR { 137,115,183 } 
        FONTCOLOR NIL
        READONLY Nil
        HORIZONTAL .F. 
    END RADIOGROUP

*------------------------------------------------------------*
*------------------------------------------------------------*
  
     @ 140, 042 BUTTON But_Print   ;  
         CAPTION "&Acept"          ;
         PICTURE "resource\ok.bmp" ;
         FONT "Arial"              ;
         SIZE 9                    ;
         BOLD                      ;
         ITALIC                    ;
         ACTION Search_Print()     ; 
         TOOLTIP "Acept"           ;
         RIGHT                     ;
         WIDTH 105                 ;
         HEIGHT 40 

      @ 140,148 BUTTON But_Cancel  ;   
         CAPTION "&Cancel"         ;
         PICTURE "resource\cancel1.bmp" ;
         FONT "Arial"              ;
         SIZE 9                    ;
         BOLD                      ;
         ITALIC                    ;
         ACTION Form_2s.Release    ;
         TOOLTIP "Cancel"          ;
         RIGHT                     ;
         WIDTH 105                 ;
         HEIGHT 40 

  END WINDOW

   CENTER WINDOW Form_2s
   ACTIVATE WINDOW Form_2s


return nil

 
*------------------------------------------------------------*
 Function Search_Print()
*------------------------------------------------------------*
  
  RESTORE FROM controlM.mem ADDITIVE

  IF nOrder = 1 
    
   DO CASE

      CASE  Form_2s.RadioGroup_Print.value = 1  

           ( Form_2s.Release , Imprimir() )

      CASE  Form_2s.RadioGroup_Print.value = 2  

           ( Form_2s.Release , Print_Pdf() )


               
   ENDCASE

 ELSE

     DO CASE

      CASE  Form_2s.RadioGroup_Print.value = 1  

               ( Form_2s.Release , Imprimir() )
             
      CASE  Form_2s.RadioGroup_Print.value = 2  
            
               ( Form_2s.Release , Print_Pdf()  )
               
    ENDCASE

 ENDIF


   Return Nil


*-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-*

*------------------------------------------------------------*
 Function Print_Pdf()
*------------------------------------------------------------*

  RESTORE FROM controlM.mem ADDITIVE

  IF nOrder = 1 
     Print_Pdf_1()
  ELSE
    Print_Pdf_2() 
 ENDIF

*------------------------------------------------------------*
 Function Print_Pdf_1()
*------------------------------------------------------------*

*------------------------------------------------------------*
*------------------------------------------------------------*
* Gentileza Cdigo Listado ---> Amarante Araruama-RJ, Brazil *
*------------------------------------------------------------*
*------------------------------------------------------------*

LOCAL _oDB_
LOCAL aReturn_Sql
LOCAL aDataRecord
LOCAL nCurrentRecord
LOCAL nTotalRecords
LOCAL cQuery_

LOCAL ID
LOCAL NOMBRE
LOCAL TELEFONO
LOCAL FECHA
LOCAL MARRIED

/*------------------------
  Access SQLITE DataBase
------------------------*/
_oDB_ := connect2db( "nombre.sqlite" )
IF _oDB_ == NIL
  * MsgStop( Msg_DSQL_000 + " " + Msg_DSQL_003 + " " + Msg_DSQL_020, Msg_DSQL_030 )
  QUIT
ENDIF

*--------------------------------- Nom Listado Pdf -----------------------------------------*
PRIVATE pagina  := 0
PRIVATE F_Mus   := 60

PRIVATE FDIA
PRIVATE FDIAx
PRIVATE HORA
PRIVATE HORAx
PUBLIC  cNumero

FDIA    := DTOC(DATE())
FDIAx   := STRTRAN(FDIA, '/')    && <--------  eliminas la barra(/)
HORA    := LEFT(TIME(), 5)
HORAx   := STRTRAN(HORA, ':')    && <--------  eliminas los dos puntos(:)
cNombre := "Listado_Pdf\" + "Listado" + "_" + FDIAx + '_' + HORAx + '.pdf'
cNumero := (  FDIAx  + '_' +  HORAx )

*--------------------------------------------------------------------------------------------*
*--------------------------------------------------------------------------------------------*
SELECT HPDFDOC cNombre TO lSuccess papersize HPDF_PAPER_A4
*-----------------------------  Cdigo Caracteres ANSI (Latinos) -----------------------------*
*------------------------------ Alternativo es lo Mismo --------------------------------------*
* SET HPDFDOC ENCODING TO "WinAnsiEncoding"
  SET HPDFDOC ENCODING TO "CP1252"
*---------------------------------------------------------------------------------------------*


/*--- Counters ---*/
nCurrentRecord := 0
nTotalRecords  := VAL( Sqlite_Cmd( _oDB_, "SELECT COUNT(*)" )[ 1, 1 ] )

/*---------------------------------------------------
  Select query
  Note that the clause "ORDER BY id" is unnecessary
  because "ID" is part of the primary key
---------------------------------------------------*/

 cQuery_ := "SELECT id, nombre, telefono, fecha, Married FROM personales ORDER BY id"

/*--- When you run the select data in return array ---*/
aReturn_Sql := Sqlite_Cmd( _oDB_, cQuery_  )


/*--- starts Document ---*/
START HPDFDOC

  /*--- start Page ---*/
  START HPDFPAGE

    /*--- Loop Reading Records ---*/
    FOR EACH aDataRecord IN aReturn_Sql

      /*--- Store Data ---*/
      ID        := aDataRecord[ 1 ]
      NOMBRE    := aDataRecord[ 2 ]
      TELEFONO  := aDataRecord[ 3 ]
      FECHA     := aDataRecord[ 4 ]
      MARRIED   := aDataRecord[ 5 ]

      /*--- Next Record ---*/
      nCurrentRecord ++

      /*--- Headline ---*/
      IF F_Mus == 60
        *--------------------------------------- Cuadro General --------------------------------------*
        @ 005,005  HPDFPRINT RECTANGLE TO 292, 206 PENWIDTH 1 ROUNDED CURVE 1
        @ 007,007  HPDFPRINT RECTANGLE TO 290, 204            ROUNDED CURVE 1
        *---------------------------------------------------------------------------------------------*
        @ 021,030 HPDFPRINT IMAGE "Resource\Logo.png" width 12 height 12
        @ 030,058 HPDFPRINT "Listado Base Datos"  FONT "Times-Roman" SIZE 25 ITALIC
        @ 030,135 HPDFPRINT dtoc(DATE()) FONT "Times-Roman" SIZE 18 ITALIC
        @ 040,015 HPDFPRINT RECTANGLE TO 48, 197  ROUNDED CURVE 1
        @ 045,020 HPDFPRINT "ID                                       NOMBRE" FONT "Times-Roman" SIZE 9 ITALIC
        @ 045,127 HPDFPRINT "TELEFONO             FECHA             MARRIED"  FONT "Times-Roman" SIZE 9 ITALIC
        *------------------------------------------ EnD -----------------------------------------------*
        *-------------------------------n pagina  ------------------------------*
        pagina ++
        @ 287, 098 HPDFPRINT "-"+SPACE(3)+ALLTRIM(STR(pagina))+SPACE(3)+"-" FONT "Times-Roman" SIZE 12 ITALIC
        *------------------------------------------------------------------------*
      ENDIF

      *------------------------------------------------------------------------*
      *--------------------------- Database  Names ----------------------------*
      *------------------------------------------------------------------------*

        *----------------------------------- REF --------------------------------*
        @ F_Mus, 14 HPDFPRINT STR( ID, 8 ) FONT "Times-Roman" SIZE 12 ITALIC
        *---------------------------------- NOM_ART -----------------------------*
        @ F_Mus, 030 HPDFPRINT LTRIM( NOMBRE) FONT "Times-Roman" SIZE 12 ITALIC
        @ F_Mus, 125 HPDFPRINT RTRIM( TELEFONO) FONT "Times-Roman" SIZE 12 ITALIC
        @ F_Mus, 150 HPDFPRINT FECHA FONT "Times-Roman" SIZE 12 ITALIC
        @ F_Mus, 180 HPDFPRINT MARRIED FONT "Times-Roman" SIZE 12 ITALIC
      *------------------------------------------------------------------------*
      *--------------------------- End Database Names -------------------------*
      *------------------------------------------------------------------------*
      
      /*--- Increases a printed line on the page and footer tests ---*/
      F_Mus += 4
      IF F_Mus > ( 60 + 210 )   // <--------------- Salto de Pgina
        F_Mus := 60
        /*--- Closes Previous Page ---*/
        END HPDFPAGE
        /*--- start New Page ---*/
        START HPDFPAGE
      ENDIF

    NEXT aDataRecord

  /*--- Closes Previous Page ---*/
  END HPDFPAGE

/*--- Closes Document ---*/
END HPDFDOC

*-------------------------------------------------------------------------------------------------------------------------*
*-------------------------------------------------------------------------------------------------------------------------*
*-------------------------------------------------------------------------------------------------------------------------*

   Execute File cNombre

   *alternativa direccion directa a impresora el PDF

   *SHELLEXECUTE( 0, "print" ,   cNombre ) //  ---> 'sample.pdf'

RETURN Nil

*-------------------------------------------------------------------------------------------------------------------------*
*-------------------------------------------------------------------------------------------------------------------------*
*-------------------------------------------------------------------------------------------------------------------------

*------------------------------------------------------------*
 Function Print_Pdf_2()
*------------------------------------------------------------*

*------------------------------------------------------------*
*------------------------------------------------------------*
* Gentileza Cdigo Listado ---> Amarante Araruama-RJ, Brazil *
*------------------------------------------------------------*
*------------------------------------------------------------*
LOCAL _oDB_
LOCAL aReturn_Sql
LOCAL aDataRecord
LOCAL nCurrentRecord
LOCAL nTotalRecords
LOCAL cQuery_

LOCAL ID
LOCAL NOMBRE
LOCAL TELEFONO
LOCAL FECHA
LOCAL MARRIED

/*------------------------
  Access SQLITE DataBase
------------------------*/
_oDB_ := connect2db( "nombre.sqlite" )
IF _oDB_ == NIL
 * MsgStop( Msg_DSQL_000 + " " + Msg_DSQL_003 + " " + Msg_DSQL_020, Msg_DSQL_030 )
  QUIT
ENDIF

*--------------------------------- Nom Listado Pdf -----------------------------------------*
PRIVATE pagina  := 0
PRIVATE F_Mus   := 60

PRIVATE FDIA
PRIVATE FDIAx
PRIVATE HORA
PRIVATE HORAx
PUBLIC  cNumero

FDIA    := DTOC(DATE())
FDIAx   := STRTRAN(FDIA, '/')    && <--------  eliminas la barra(/)
HORA    := LEFT(TIME(), 5)
HORAx   := STRTRAN(HORA, ':')    && <--------  eliminas los dos puntos(:)
cNombre := "Listado_Pdf\" + "Listado" + "_" + FDIAx + '_' + HORAx + '.pdf'
cNumero := (  FDIAx  + '_' +  HORAx )

*--------------------------------------------------------------------------------------------*
*--------------------------------------------------------------------------------------------*
SELECT HPDFDOC cNombre TO lSuccess papersize HPDF_PAPER_A4
*-----------------------------  Cdigo Caracteres ANSI (Latinos) -----------------------------*
*------------------------------ Alternativo es lo Mismo --------------------------------------*
* SET HPDFDOC ENCODING TO "WinAnsiEncoding"
  SET HPDFDOC ENCODING TO "CP1252"
*---------------------------------------------------------------------------------------------*


/*--- Counters ---*/
nCurrentRecord := 0
nTotalRecords  := VAL( Sqlite_Cmd( _oDB_, "SELECT COUNT(*)" )[ 1, 1 ] )

/*---------------------------------------------------
  Select query
  Note that the clause "ORDER BY id" is unnecessary
  because "ID" is part of the primary key
---------------------------------------------------*/


   cQuery_ := "SELECT id, nombre, telefono, fecha, Married FROM personales ORDER BY nombre"


/*--- When you run the select data in return array ---*/
aReturn_Sql := Sqlite_Cmd( _oDB_, cQuery_  )


/*--- starts Document ---*/
START HPDFDOC

  /*--- start Page ---*/
  START HPDFPAGE

    /*--- Loop Reading Records ---*/
    FOR EACH aDataRecord IN aReturn_Sql

      /*--- Store Data ---*/
      ID        := aDataRecord[ 1 ]
      NOMBRE    := aDataRecord[ 2 ]
      TELEFONO  := aDataRecord[ 3 ]
      FECHA     := aDataRecord[ 4 ]
      MARRIED   := aDataRecord[ 5 ]

      /*--- Next Record ---*/
      nCurrentRecord ++

      /*--- Headline ---*/
      IF F_Mus == 60
        *--------------------------------------- Cuadro General --------------------------------------*
        @ 005,005  HPDFPRINT RECTANGLE TO 292, 206 PENWIDTH 1 ROUNDED CURVE 1
        @ 007,007  HPDFPRINT RECTANGLE TO 290, 204            ROUNDED CURVE 1
        *---------------------------------------------------------------------------------------------*
        @ 021,030 HPDFPRINT IMAGE "Resource\Logo.png" width 12 height 12
        @ 030,058 HPDFPRINT "Listado Base Datos"  FONT "Times-Roman" SIZE 25 ITALIC
        @ 030,135 HPDFPRINT  dtoc(DATE()) FONT "Times-Roman" SIZE 18 ITALIC
        @ 040,015 HPDFPRINT RECTANGLE TO 48, 197  ROUNDED CURVE 1
        @ 045,020 HPDFPRINT "ID                                       NOMBRE" FONT "Times-Roman" SIZE 9 ITALIC
        @ 045,127 HPDFPRINT "TELEFONO             FECHA             MARRIED"  FONT "Times-Roman" SIZE 9 ITALIC
        *------------------------------------------ EnD -----------------------------------------------*
        *-------------------------------n pagina  ------------------------------*
        pagina ++
        @ 287, 098 HPDFPRINT "-"+SPACE(3)+ALLTRIM(STR(pagina))+SPACE(3)+"-" FONT "Times-Roman" SIZE 12 ITALIC
        *------------------------------------------------------------------------*
      ENDIF

      *------------------------------------------------------------------------*
      *--------------------------- Database  Names ----------------------------*
      *------------------------------------------------------------------------*

      *----------------------------------- REF --------------------------------*
         @ F_Mus, 14 HPDFPRINT STR( ID, 8 ) FONT "Times-Roman" SIZE 12 ITALIC
      *---------------------------------- NOM_ART -----------------------------*
         @ F_Mus, 030 HPDFPRINT LTRIM( NOMBRE) FONT "Times-Roman" SIZE 12 ITALIC
         @ F_Mus, 125 HPDFPRINT RTRIM( TELEFONO) FONT "Times-Roman" SIZE 12 ITALIC
         @ F_Mus, 150 HPDFPRINT FECHA FONT "Times-Roman" SIZE 12 ITALIC
         @ F_Mus, 180 HPDFPRINT MARRIED FONT "Times-Roman" SIZE 12 ITALIC
      *------------------------------------------------------------------------*
      *--------------------------- End Database Names -------------------------*
      *------------------------------------------------------------------------*
      
      /*--- Increases a printed line on the page and footer tests ---*/
      F_Mus += 4
      IF F_Mus > ( 60 + 210 )   // <--------------- Salto de Pgina
        F_Mus := 60
        /*--- Closes Previous Page ---*/
        END HPDFPAGE
        /*--- start New Page ---*/
        START HPDFPAGE
      ENDIF

    NEXT aDataRecord

  /*--- Closes Previous Page ---*/
  END HPDFPAGE

/*--- Closes Document ---*/
END HPDFDOC

*-------------------------------------------------------------------------------------------------------------------------*
*-------------------------------------------------------------------------------------------------------------------------*
*-------------------------------------------------------------------------------------------------------------------------*

  Execute File cNombre

  *alternativa direccion directa a impresora el PDF

  *SHELLEXECUTE( 0, "print" ,   cNombre ) //  ---> 'sample.pdf'

RETURN Nil


*---------------------------------------------------------------------------------------------------------------*











